require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC64_IO_H)) {
    eval 'sub __SPARC64_IO_H () {1;}' unless defined(&__SPARC64_IO_H);
    require 'linux/kernel.ph';
    require 'linux/types.ph';
    require 'asm/page.ph';
    require 'asm/system.ph';
    require 'asm/asi.ph';
    eval 'sub __SLOW_DOWN_IO () { &do { }  &while (0);}' unless defined(&__SLOW_DOWN_IO);
    eval 'sub SLOW_DOWN_IO () { &do { }  &while (0);}' unless defined(&SLOW_DOWN_IO);
    eval 'sub virt_to_bus () { &virt_to_bus_not_defined_use_pci_map;}' unless defined(&virt_to_bus);
    eval 'sub bus_to_virt () { &bus_to_virt_not_defined_use_pci_map;}' unless defined(&bus_to_virt);
    eval 'sub page_to_phys {
        local($page) = @_;
	    eval q((((($page) -  &mem_map) <<  &PAGE_SHIFT)+ &phys_base));
    }' unless defined(&page_to_phys);
    eval 'sub bus_dvma_to_mem {
        local($__vaddr) = @_;
	    eval q((($__vaddr) &  &pci_memspace_mask));
    }' unless defined(&bus_dvma_to_mem);
    eval 'sub inb_p () { &inb;}' unless defined(&inb_p);
    eval 'sub outb_p () { &outb;}' unless defined(&outb_p);
    eval 'sub inw_p () { &inw;}' unless defined(&inw_p);
    eval 'sub outw_p () { &outw;}' unless defined(&outw_p);
    eval 'sub inl_p () { &inl;}' unless defined(&inl_p);
    eval 'sub outl_p () { &outl;}' unless defined(&outl_p);
    eval 'sub readb {
        local($__addr) = @_;
	    eval q(( &_readb(($__addr))));
    }' unless defined(&readb);
    eval 'sub readw {
        local($__addr) = @_;
	    eval q(( &_readw(($__addr))));
    }' unless defined(&readw);
    eval 'sub readl {
        local($__addr) = @_;
	    eval q(( &_readl(($__addr))));
    }' unless defined(&readl);
    eval 'sub readq {
        local($__addr) = @_;
	    eval q(( &_readq(($__addr))));
    }' unless defined(&readq);
    eval 'sub writeb {
        local($__b, $__addr) = @_;
	    eval q(( &_writeb(, ($__addr))));
    }' unless defined(&writeb);
    eval 'sub writew {
        local($__w, $__addr) = @_;
	    eval q(( &_writew(, ($__addr))));
    }' unless defined(&writew);
    eval 'sub writel {
        local($__l, $__addr) = @_;
	    eval q(( &_writel(, ($__addr))));
    }' unless defined(&writel);
    eval 'sub writeq {
        local($__q, $__addr) = @_;
	    eval q(( &_writeq(, ($__addr))));
    }' unless defined(&writeq);
    eval 'sub __raw_readb {
        local($__addr) = @_;
	    eval q(( &_raw_readb(($__addr))));
    }' unless defined(&__raw_readb);
    eval 'sub __raw_readw {
        local($__addr) = @_;
	    eval q(( &_raw_readw(($__addr))));
    }' unless defined(&__raw_readw);
    eval 'sub __raw_readl {
        local($__addr) = @_;
	    eval q(( &_raw_readl(($__addr))));
    }' unless defined(&__raw_readl);
    eval 'sub __raw_readq {
        local($__addr) = @_;
	    eval q(( &_raw_readq(($__addr))));
    }' unless defined(&__raw_readq);
    eval 'sub __raw_writeb {
        local($__b, $__addr) = @_;
	    eval q(( &_raw_writeb(, ($__addr))));
    }' unless defined(&__raw_writeb);
    eval 'sub __raw_writew {
        local($__w, $__addr) = @_;
	    eval q(( &_raw_writew(, ($__addr))));
    }' unless defined(&__raw_writew);
    eval 'sub __raw_writel {
        local($__l, $__addr) = @_;
	    eval q(( &_raw_writel(, ($__addr))));
    }' unless defined(&__raw_writel);
    eval 'sub __raw_writeq {
        local($__q, $__addr) = @_;
	    eval q(( &_raw_writeq(, ($__addr))));
    }' unless defined(&__raw_writeq);
    eval 'sub IO_SPACE_LIMIT () {1.84467440737096e+19;}' unless defined(&IO_SPACE_LIMIT);
    eval 'sub sbus_readb {
        local($__addr) = @_;
	    eval q(( &_sbus_readb(($__addr))));
    }' unless defined(&sbus_readb);
    eval 'sub sbus_readw {
        local($__addr) = @_;
	    eval q(( &_sbus_readw(($__addr))));
    }' unless defined(&sbus_readw);
    eval 'sub sbus_readl {
        local($__addr) = @_;
	    eval q(( &_sbus_readl(($__addr))));
    }' unless defined(&sbus_readl);
    eval 'sub sbus_writeb {
        local($__b, $__addr) = @_;
	    eval q(( &_sbus_writeb(, ($__addr))));
    }' unless defined(&sbus_writeb);
    eval 'sub sbus_writew {
        local($__w, $__addr) = @_;
	    eval q(( &_sbus_writew(, ($__addr))));
    }' unless defined(&sbus_writew);
    eval 'sub sbus_writel {
        local($__l, $__addr) = @_;
	    eval q(( &_sbus_writel(, ($__addr))));
    }' unless defined(&sbus_writel);
    eval 'sub sbus_memset_io {
        local($d,$c,$sz) = @_;
	    eval q( &_sbus_memset_io($d,$c,$sz));
    }' unless defined(&sbus_memset_io);
    eval 'sub memset_io {
        local($d,$c,$sz) = @_;
	    eval q( &_memset_io($d,$c,$sz));
    }' unless defined(&memset_io);
    eval 'sub memcpy_fromio {
        local($d,$s,$sz) = @_;
	    eval q( &_memcpy_fromio($d,$s,$sz));
    }' unless defined(&memcpy_fromio);
    eval 'sub memcpy_toio {
        local($d,$s,$sz) = @_;
	    eval q( &_memcpy_toio($d,$s,$sz));
    }' unless defined(&memcpy_toio);
    if(defined(&__KERNEL__)) {
	eval 'sub ioremap {
	    local($__offset, $__size) = @_;
    	    eval q((($__offset)));
	}' unless defined(&ioremap);
	eval 'sub ioremap_nocache {
	    local($X,$Y) = @_;
    	    eval q( &ioremap(($X),($Y)));
	}' unless defined(&ioremap_nocache);
	eval 'sub iounmap {
	    local($__addr) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&iounmap);
	eval 'sub sbus_ioremap {
	    local($__res, $__offset, $__size, $__name) = @_;
    	    eval q(({ \'unsigned long __ret\';  &__ret = -> &start + ((-> &flags & 0x1ff) << 32);  &__ret += ($__offset);  &if (!  &request_region(( &__ret), ($__size), ($__name)))  &__ret = 0;  &__ret; }));
	}' unless defined(&sbus_ioremap);
	eval 'sub sbus_iounmap {
	    local($__addr, $__size) = @_;
    	    eval q( &release_region(($__addr), ($__size)));
	}' unless defined(&sbus_iounmap);
	eval 'sub dma_cache_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_inv);
	eval 'sub dma_cache_wback {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback);
	eval 'sub dma_cache_wback_inv {
	    local($_start,$_size) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&dma_cache_wback_inv);
    }
}
1;
